package com.terraformersmc.terraform.block;

import net.minecraft.block.*;
import net.minecraft.class_1937;
import net.minecraft.class_1941;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2372;
import net.minecraft.class_2488;
import net.minecraft.class_2680;
import net.minecraft.class_3486;
import net.minecraft.class_3558;
import java.util.Random;

/**
 * A custom grass block that allows one to define their own soil types, used for things like basalt grass.
 */
public class TerraformGrassBlock extends class_2372 {
	private class_2248 dirt;

	public TerraformGrassBlock(class_2248 dirt, class_2248.class_2251 settings) {
		super(settings);

		this.dirt = dirt;
	}

	private static boolean canSurvive(class_2680 state, class_1941 world, class_2338 pos) {
		class_2338 above = pos.method_10084();
		class_2680 aboveState = world.method_8320(above);

		if (aboveState.method_11614() == class_2246.field_10477 && aboveState.method_11654(class_2488.field_11518) == 1) {
			return true;
		} else {
			int lightingAt = class_3558.method_20049(world, state, pos, aboveState, above, class_2350.field_11036, aboveState.method_11581(world, above));
			return lightingAt < world.method_8315();
		}
	}

	private static boolean canSpread(class_2680 state, class_1941 world, class_2338 pos) {
		class_2338 above = pos.method_10084();
		return canSurvive(state, world, pos) && !world.method_8316(above).method_15767(class_3486.field_15517);
	}

	public void method_9588(class_2680 state, class_1937 world, class_2338 pos, Random random) {
		if (!world.field_9236) {
			if (!canSurvive(state, world, pos)) {
				world.method_8501(pos, dirt.method_9564());
			} else if (world.method_8602(pos.method_10084()) >= 4) {
				if (world.method_8602(pos.method_10084()) >= 9) {
					class_2680 defaultState = this.method_9564();

					for (int int_1 = 0; int_1 < 4; ++int_1) {
						class_2338 blockPos_2 = pos.method_10069(random.nextInt(3) - 1, random.nextInt(5) - 3, random.nextInt(3) - 1);

						if (world.method_8320(blockPos_2).method_11614() == dirt && canSpread(defaultState, world, blockPos_2)) {
							world.method_8501(blockPos_2, defaultState.method_11657(field_11522, world.method_8320(blockPos_2.method_10084()).method_11614() == class_2246.field_10477));
						}
					}
				}

			}
		}
	}
}
