package com.terraformersmc.terraform.feature;

import com.mojang.datafixers.Dynamic;
import java.util.Random;
import java.util.Set;
import java.util.function.Function;
import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2410;
import net.minecraft.class_2680;
import net.minecraft.class_2944;
import net.minecraft.class_3111;
import net.minecraft.class_3341;
import net.minecraft.class_3747;

public class FallenLogFeature extends class_2944<class_3111> {
    private final class_2680 log;
    private final int minLength, variance;

    public FallenLogFeature(Function<Dynamic<?>, ? extends class_3111> function, boolean notify, class_2680 log) {
        this(function, notify, log, 5, 8);
    }

    public FallenLogFeature(Function<Dynamic<?>, ? extends class_3111> function, boolean notify, class_2680 log, int minLength, int variance) {
        super(function, notify);
        this.log = log;
        this.minLength = minLength;
        this.variance = variance;
    }

    @Override
    public boolean method_12775(Set<class_2338> blocks, class_3747 world, Random rand, class_2338 origin, class_3341 boundingBox) {
        // Total log length
        int length = rand.nextInt(variance) + minLength;

        // Axis
        class_2350.class_2351 axis = rand.nextBoolean() ? class_2350.class_2351.field_11048 : class_2350.class_2351.field_11051;
        class_2350 direction = class_2350.method_10169(axis, rand.nextBoolean() ? class_2350.class_2352.field_11056 : class_2350.class_2352.field_11060);

        class_2338 below = origin.method_10074();
        if (!method_16430(world, below)) {
            return false;
        }

        class_2338.class_2339 pos = new class_2338.class_2339(origin);

        int air = 0;
        for (int i = 0; i < length; i++) {
            pos.method_10098(direction);

            if (!world.method_16358(pos.method_10098(class_2350.field_11033), class_2680::method_11619)) {
                air++;
            }

            if (!method_16420(world, pos.method_10098(class_2350.field_11036))) {
                return false;
            }
        }

        // No floating logs
        if (air * 2 > length) {
            return false;
        }

        pos.method_10101(origin);
        for (int i = 0; i < length; i++) {
            pos.method_10098(direction);

            method_12773(blocks, world, pos, log.method_11657(class_2410.field_11459, axis), boundingBox);

            pos.method_10098(class_2350.field_11033);

            if (method_16430(world, pos)) {
                method_12773(blocks, world, pos, class_2246.field_10566.method_9564(), boundingBox);
            }

            pos.method_10098(class_2350.field_11036);
        }

        return true;
    }
}
